// BenLincoln.DaVinci.GUI - A shared library used by The Mirror's Surface Breaks
// Copyright 2010-2011 Ben Lincoln
// http://www.beneaththewaves.net/
//

// This file is part of BenLincoln.DaVinci.GUI.

// BenLincoln.DaVinci.GUI is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.DaVinci.GUI is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.DaVinci.GUI (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace BenLincoln.DaVinci.GUI
{
    public partial class frmPleaseWait : Form
    {
        protected Thread _ShowThread;

        public frmPleaseWait()
        {
            InitializeComponent();
        }

        public void ShowThreaded()
        {
            _ShowThread = new Thread(new ThreadStart(ShowThreadedFunction));
            _ShowThread.Start();
        }

        protected void ShowThreadedFunction()
        {
            //this.Show();
            Thread t2 = new Thread(new ThreadStart(Show));
            t2.Start();
            this.BringToFront();
            this.Activate();
        }

        public void CloseThreaded()
        {
            CloseThreadedFunction();
        }

        delegate void CloseThreadedCallback();

        protected void CloseThreadedFunction()
        {
            if (this.InvokeRequired)
            {
                CloseThreadedCallback c = new CloseThreadedCallback(CloseThreadedFunction);
                this.Invoke(c);
            }
            else
            {
                if ((_ShowThread != null) && (_ShowThread.IsAlive))
                {
                    _ShowThread.Abort();
                    _ShowThread = null;
                }
                this.Close();
            }
        }

        //public void ShowThreaded()
        //{
        //    _ShowThread = new Thread(new ThreadStart(Show));
        //    _ShowThread.Start();
        //}

        //public void CloseThreaded()
        //{
        //    CloseThreadedFunction();
        //}

        //delegate void CloseThreadedCallback();

        //protected void CloseThreadedFunction()
        //{
        //    if (this.InvokeRequired)
        //    {
        //        CloseThreadedCallback c = new CloseThreadedCallback(CloseThreadedFunction);
        //        this.Invoke(c);
        //    }
        //    else
        //    {
        //        if ((_ShowThread != null) && (_ShowThread.IsAlive))
        //        {
        //            _ShowThread.Abort();
        //            _ShowThread = null;
        //        }
        //        this.Close();
        //    }
        //}
    }
}