// BenLincoln.DaVinci - A shared library used by The Mirror's Surface Breaks
// Copyright 2010-2011 Ben Lincoln
// http://www.beneaththewaves.net/
//

// This file is part of BenLincoln.DaVinci.

// BenLincoln.DaVinci is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.DaVinci is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.DaVinci (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Text;

namespace BenLincoln.DaVinci
{
    public class ScriptVariable : IComparable
    {
        protected string _Name;
        protected string _Value;

        #region Properties

        public string Name
        {
            get
            {
                return _Name;
            }
            set
            {
                _Name = value;
            }
        }

        public string Value
        {
            get
            {
                return _Value;
            }
            set
            {
                _Value = value;
            }
        }

        #endregion

        public ScriptVariable()
        {
            _Name = "";
            _Value = "";
        }

        public ScriptVariable(string name, string value)
            : this()
        {
            Name = name;
            Value = value;
        }

        public ScriptVariable(ScriptVariable sourceVariable)
            : this()
        {
            Name = sourceVariable.Name;
            Value = sourceVariable.Value;
        }

        public int CompareTo(object obj)
        {
            if (obj is ScriptVariable)
            {
                ScriptVariable b2 = (ScriptVariable)obj;
                return Name.CompareTo(b2.Name);
            }
            else
            {
                return Name.CompareTo(obj.ToString());
            }
        }
    }
}
