// BenLincoln.DaVinci - A shared library used by The Mirror's Surface Breaks
// Copyright 2010-2011 Ben Lincoln
// http://www.beneaththewaves.net/
//

// This file is part of BenLincoln.DaVinci.

// BenLincoln.DaVinci is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.DaVinci is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.DaVinci (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Text;

namespace BenLincoln.DaVinci
{
    public class TintMapping
    {
        protected CustomChannelReference _Channel;
        //protected string[] _TintNames;
        protected string _TintName;
        protected bool _IncludeInSecondOrderImages;

        #region Properties

        public CustomChannelReference Channel
        {
            get
            {
                return _Channel;
            }
            set
            {
                _Channel = value;
            }
        }

        //public string[] TintNames
        //{
        //    get
        //    {
        //        return _TintNames;
        //    }
        //    set
        //    {
        //        _TintNames = value;
        //    }
        //}

        public string TintName
        {
            get
            {
                return _TintName;
            }
            set
            {
                _TintName = value;
            }
        }

        /// <summary>
        /// Controls whether or not images based on this tinting colour will be used as the basis 
        /// for second-order images (Luma/Colour, etc.)
        /// </summary>
        public bool IncludeInSecondOrderImages
        {
            get
            {
                return _IncludeInSecondOrderImages;
            }
            set
            {
                _IncludeInSecondOrderImages = value;
            }
        }

        #endregion

        public TintMapping()
        {
            _Channel = new CustomChannelReference();
            //_TintNames = new string[0];
            TintName = "";
            _IncludeInSecondOrderImages = true;
        }

        //public void AddTintName(string newTintName)
        //{
        //    Array.Resize(ref _TintNames, _TintNames.Length + 1);
        //    _TintNames[_TintNames.Length - 1] = newTintName;
        //}
    }
}
